#!/usr/bin/perl
#=======================================================================
# Copyright (c) 2002 Daniele Giacomini daniele@swlibero.org
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#======================================================================
# n_lettere.pl <x>
#======================================================================

#======================================================================
# &integer_to_italian (<n>)
#----------------------------------------------------------------------
sub integer_to_italian
{
    local ($n) = $_[0];
    local ($x) = 0;
    local ($y) = 0;

    if ($n == 0)
      {
	return "";
      }
    elsif ($n == 1)
      {
	return "uno";
      }
    elsif ($n == 2)
      {
	return "due";
      }
    elsif ($n == 3)
      {
	return "tre";
      }
    elsif ($n == 4)
      {
	return "quattro";
      }
    elsif ($n == 5)
      {
	return "cinque";
      }
    elsif ($n == 6)
      {
	return "sei";
      }
    elsif ($n == 7)
      {
	return "sette";
      }
    elsif ($n == 8)
      {
	return "otto";
      }
    elsif ($n == 9)
      {
	return "nove";
      }
    elsif ($n == 10)
      {
	return "dieci";
      }
    elsif ($n == 11)
      {
	return "undici";
      }
    elsif ($n == 12)
      {
	return "dodici";
      }
    elsif ($n == 13)
      {
	return "tredici";
      }
    elsif ($n == 14)
      {
	return "quattordici";
      }
    elsif ($n == 15)
      {
	return "quindici";
      }
    elsif ($n == 16)
      {
	return "sedici";
      }
    elsif ($n == 17)
      {
	return "diciassette";
      }
    elsif ($n == 18)
      {
	return "diciotto";
      }
    elsif ($n == 19)
      {
	return "diciannove";
      }
    elsif ($n == 20)
      {
	return "venti";
      }
    elsif ($n == 21)
      {
	return "ventuno";
      }
    elsif (($n >= 22) && ($n <= 29))
      {
	return "venti" . &integer_to_italian ($n-20);
      }
    elsif ($n == 30)
      {
	return "trenta";
      }
    elsif ($n == 31)
      {
	return "trentuno";
      }
    elsif (($n >= 32) && ($n <= 39))
      {
	return "trenta" . &integer_to_italian ($n-30);
      }
    elsif ($n == 40)
      {
	return "quaranta";
      }
    elsif ($n == 41)
      {
	return "quarantuno";
      }
    elsif (($n >= 42) && ($n <= 49))
      {
	return "quaranta" . &integer_to_italian ($n-40);
      }
    elsif ($n == 50)
      {
	return "cinquanta";
      }
    elsif ($n == 51)
      {
	return "cinquantuno";
      }
    elsif (($n >= 52) && ($n <= 59))
      {
	return "cinquanta" . &integer_to_italian ($n-50);
      }
    elsif ($n == 60)
      {
	return "sessanta";
      }
    elsif ($n == 61)
      {
	return "sessantuno";
      }
    elsif (($n >= 62) && ($n <= 69))
      {
	return "sessanta" . &integer_to_italian ($n-60);
      }
    elsif ($n == 70)
      {
	return "settanta";
      }
    elsif ($n == 71)
      {
	return "settantuno";
      }
    elsif (($n >= 72) && ($n <= 79))
      {
	return "settanta" . &integer_to_italian ($n-70);
      }
    elsif ($n == 80)
      {
	return "ottanta";
      }
    elsif ($n == 81)
      {
	return "ottantuno";
      }
    elsif (($n >= 82) && ($n <= 89))
      {
	return "ottanta" . &integer_to_italian ($n-80);
      }
    elsif ($n == 90)
      {
	return "novanta";
      }
    elsif ($n == 91)
      {
	return "novantuno";
      }
    elsif (($n >= 92) && ($n <= 99))
      {
	return "novanta" . &integer_to_italian ($n-90);
      }
    elsif (($n >= 100) && ($n <= 199))
      {
	return "cento" . &integer_to_italian ($n-100);
      }
    elsif (($n >= 200) && ($n <= 999))
      {
	$x = int ($n / 100);
	$y = $n - ($x * 100);
	return &integer_to_italian ($x)
	       . "cento"
	       . &integer_to_italian ($y);
      }
    elsif (($n >= 1000) && ($n <= 1999))
      {
	return "mille" . &integer_to_italian ($n-1000);
      }
    elsif (($n >= 2000) && ($n <= 999999))
      {
	$x = int ($n / 1000);
	$y = $n - ($x * 1000);
	return &integer_to_italian ($x)
	       . "mila"
	       . &integer_to_italian ($y);
      }
    elsif (($n >= 1000000) && ($n <= 1999999))
      {
	return "unmilione" . &integer_to_italian ($n-1000000);
      }
    elsif (($n >= 2000000) && ($n <= 999999999))
      {
	$x = int ($n / 1000000);
	$y = $n - ($x * 1000000);
	return &integer_to_italian ($x)
	       . "milioni"
	       . &integer_to_italian ($y);
      }
    elsif (($n >= 1000000000) && ($n <= 1999999999))
      {
	return "unmiliardo" . &integer_to_italian ($n-1000000000);
      }
    elsif (($n >= 2000000000) && ($n <= 999999999999))
      {
	$x = int ($n / 1000000000);
	$y = $n - ($x * 1000000000);
	return &integer_to_italian ($x)
	       . "miliardi"
	       . &integer_to_italian ($y);
      }
}

$n = $ARGV[0];

print (&integer_to_italian ($n));
print ("\n");

